package cup.chap2.bugtrack;
import java.rmi.*;
import java.rmi.registry.LocateRegistry;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.sql.*;

public class BugTrackServer extends UnicastRemoteObject implements BugTrackInterface {
	private String name ;
	private Connection con ;
	DBConnectionPool myPool;
	
	public BugTrackServer (String serverName)  throws java.rmi.RemoteException {
		super();
		name=serverName;
		myPool = new DBConnectionPool("jdbc:odbc:bugdb1","sun.jdbc.odbc.JdbcOdbcDriver","dba","sql",5,false);
	}

/**
	bugtrack() dynamically creates and executes a query and
	returns the results back to the applet
**/

	public Vector bugtrack(Vector queryData) throws RemoteException {
	
		// obtain a connection from the pool
		Connection c = (Connection) myPool.getConnection();

		int statCd = ((Integer)queryData.elementAt(0)).intValue();		
		int priorCd = ((Integer)queryData.elementAt(1)).intValue();
		int dateCd = ((Integer)queryData.elementAt(2)).intValue();

		String query="SELECT bug_id, summary, priority.description, status.description, report_date  from bugs, status, priority where bugs.sts=status.stat_cd and bugs.pty=priority.prior_cd";

	      if (statCd !=0 )query = query + " and status.stat_cd="+statCd;
		
	      if (priorCd !=0 ) query = query + " and priority.prior_cd="+priorCd;

		if (dateCd !=0 ) {
			String from = (String)queryData.elementAt(3);
			String to = (String)queryData.elementAt(4);
			query = query + " and (bugs.report_date >= {d '"+from+"'} and bugs.report_date <= {d '"+to+"'} )";
		}	   
		ResultSet rs=null;
		Vector test =new Vector();
		Statement stmt=null;
		try {
	
	  	      stmt = c.createStatement();
			rs = stmt.executeQuery(query);
	
			test.addElement(new Integer(0));
			while (rs.next()) {	
	           	    String result = rs.getString(1)+" | "+rs.getString(2)+" | "+rs.getString(3)+" | "+rs.getString(4)+" | "+(rs.getDate(5)).toString();              	
			    test.addElement(result.trim());
    			}			
		} catch (Exception e) {
			test.addElement(new Integer(1));
			test.addElement(e);			
			System.out.println("Error:"+e);
		} finally {
			// release the connection back to the pool
			myPool.freeConnection(c);
		}
		return test;           
	}
/**
	main() creates a registry, and binds an instance of the
	remote object into the registry
**/

	public static void main(String[] args) {
	  System.setSecurityManager(new RMISecurityManager());

	  try {
		System.out.println("BugTrackServer.main: creating registry");	
		LocateRegistry.createRegistry(1099);
	       System.out.println("BugTrackServer.main: creating server");
	       BugTrackServer myBugTrackServer=new BugTrackServer("BugTrackServer");
	       Naming.rebind("/BugTrackServer", myBugTrackServer);
	       System.out.println("BugTrackServer bound in registry");
	      }
	      catch (Exception e) {
	        System.out.println("Exception on bind: "+e);
	      }
	}
}
