package cup.chap2.bugtrack;
import java.awt.*;
import java.applet.*;
import java.util.Vector;
import java.rmi.*;
import java.sql.*;

public class BugTrackerApplet extends Applet {
/**
	init() sets the layout for the applet, and
	creates a GUI. Don't worry too much about the
	GUI code...much of it was generated using an
	IDE. (Which is what you will be most likely
	be doing anyway!
**/

	public void init() {
		setLayout(null);
		setSize(800,400);
		title = new java.awt.Label("BUG TRACKER");
		title.setBounds(198,6,136,24);
		title.setFont(new Font("SansSerif", Font.BOLD, 18));
		add(title);
		priorityLabel = new java.awt.Label("Priority");
		priorityLabel.setBounds(60,48,40,17);
		priorityLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		add(priorityLabel);
		statusLabel = new java.awt.Label("Status");
		statusLabel.setBounds(252,48,40,17);
		statusLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		add(statusLabel);
		gpPriority = new CheckboxGroup();
		rbCritical = new Checkbox ("Critical", gpPriority, false);
		rbCritical.setBounds(108,48,64,17);
		add(rbCritical);
		rbHigh = new Checkbox ("High", gpPriority, false);
		rbHigh.setBounds(180,48,48,17);
		add(rbHigh);
		rbMedium = new Checkbox ("Medium", gpPriority, false);
		rbMedium.setBounds(108,72,64,17);
		add(rbMedium);
		rbLow = new Checkbox ("Low", gpPriority, false);
		rbLow.setBounds(180,72,48,17);
		add(rbLow);
		gpStatus = new CheckboxGroup();
		rbComplete = new Checkbox ("Resolved", gpStatus, false);
		rbComplete.setBounds(300,48,88,19);
		add(rbComplete);
		rbInProgress = new Checkbox ("In Progress", gpStatus, false);
		rbInProgress.setBounds(396,48,88,19);
		add(rbInProgress);
		rbUnassigned = new Checkbox ("Unassigned", gpStatus, false);
		rbUnassigned.setBounds(300,72,88,19);
		add(rbUnassigned);
		rbAllPriority = new Checkbox ("All", gpPriority, true);
		rbAllPriority.setBounds(108,96,40,17);
		add(rbAllPriority);
		rbAllStatus = new Checkbox ("All", gpStatus, true);
		rbAllStatus.setBounds(396,72,40,19);
		add(rbAllStatus);
		dateLabel = new java.awt.Label("Date");
		dateLabel.setBounds(60,120,32,17);
		dateLabel.setFont(new Font("Dialog", Font.BOLD, 12));
		add(dateLabel);
		fromDate = new java.awt.TextField();
		fromDate.setBounds(258,120,93,23);
		add(fromDate);
		toDate = new java.awt.TextField();
		toDate.setBounds(390,120,93,23);
		add(toDate);
		dateLabel2 = new java.awt.Label("To");
		dateLabel2.setBounds(366,120,24,17);
		dateLabel2.setFont(new Font("Dialog", Font.BOLD, 12));
		add(dateLabel2);
		gpDate = new CheckboxGroup();
		rbRange = new Checkbox ("Specify Range", gpDate, false);
		rbRange.setBounds(108,120,104,17);
		add(rbRange);
		dateLabel3 = new java.awt.Label("From");
		dateLabel3.setBounds(222,120,32,17);
		dateLabel3.setFont(new Font("Dialog", Font.BOLD, 12));
		add(dateLabel3);
		rbAllDates = new Checkbox ("All", gpDate, true);
		rbAllDates.setBounds(108,144,40,17);
		add(rbAllDates);
		buttonSearch = new java.awt.Button();
		buttonSearch.setLabel("Search");
		buttonSearch.setBounds(222,162,92,22);
		buttonSearch.setBackground(new Color(12632256));
		add(buttonSearch);
		results = new java.awt.List(4);
		add(results);
		results.setBounds(8,192,544,120);
	
		// register listeners
		UserAction lUserAction = new UserAction();
		buttonSearch.addActionListener(lUserAction);
		SymItem lSymItem = new SymItem();
		rbRange.addItemListener(lSymItem);
		rbAllDates.addItemListener(lSymItem);
		results.addActionListener(lUserAction);

		try {
		      // get hold of the remote object's stub
		      server = (BugTrackInterface)
		      Naming.lookup("rmi://"+getCodeBase().getHost()+"/BugTrackServer");
    System.out.println("rmi://"+getCodeBase().getHost()+"/BugTrackServer");
        } catch (Exception e) {
            System.out.println("Could not reach BugTrackServer");
        }
        
	}
	
	//controls
	Label title;
	Label priorityLabel;
	Label statusLabel;
	Checkbox  rbCritical;
	CheckboxGroup gpPriority;
	Checkbox  rbHigh;
	Checkbox  rbMedium;
	Checkbox  rbLow;
	Checkbox  rbComplete;
	CheckboxGroup gpStatus;
	Checkbox  rbInProgress;
	Checkbox  rbUnassigned;
	Checkbox  rbAllPriority;
	Checkbox  rbAllStatus;
	Label dateLabel;
	TextField fromDate;
	TextField toDate;
	Label dateLabel2;
	Checkbox  rbRange;
	CheckboxGroup gpDate;
	Label dateLabel3;
	Checkbox  rbAllDates;
	Button buttonSearch;
	java.awt.List results;
	BugTrackInterface server;

	class UserAction implements java.awt.event.ActionListener	{
		public void actionPerformed(java.awt.event.ActionEvent e) {
			Object object = e.getSource();
			if (object == buttonSearch)
				buttonSearch_ActionPerformed(e);			
		}
	}
/**
	Gather the user query params, perform the database lookup
	via the remote object, and append results to the list box
**/

	void buttonSearch_ActionPerformed(java.awt.event.ActionEvent e) {
 		results.clear();
		String status = gpStatus.getCurrent().getLabel();
		String priority = gpPriority.getCurrent().getLabel();
		String date = gpDate.getCurrent().getLabel();		
		
		int statCd, priorCd;
		
		if (status.equals("Resolved")) statCd=3;
	      	else if (status.equals("In Progress")) statCd=2;
  	      	else if (status.equals("Unassigned")) statCd=1;	    
 	      	else statCd=0;

 	      if (priority.equals("Critical")) priorCd=1;
	      else if (priority.equals("High")) priorCd=2;	    
	      else if (priority.equals("Medium")) priorCd=3;	    
  	      else if (priority.equals("Low")) priorCd=4;	    	    
  	      else priorCd=0;

              Vector data = new Vector();
              data.addElement(new Integer(statCd));
              data.addElement(new Integer(priorCd));
        
            int dateCd=0;
        
            if (date.equals("Specify Range")) {
           		dateCd=1;
            	data.addElement(new Integer(dateCd));
	            data.addElement(fromDate.getText());
  	            data.addElement(toDate.getText());	        
		} else data.addElement(new Integer(dateCd));
	      try {
   	 		Vector res = server.bugtrack(data);
		 	int errcode = ((Integer)res.elementAt(0)).intValue();
		      if (errcode == 0 ) { //all ok 
	    	      	for (int i=1; i< res.size();i++) {
	                  	String arow = (String) res.elementAt(i);     	    
		                  results.addItem(arow);
		            }
		    	} else {
		    	    Exception ex = (Exception) res.elementAt(1);
		    	    results.addItem(ex.toString());
		      }    	   
	    	} catch (Exception ex1) {
    	      	System.out.println("Error:"+ex1);
	    	}
	}

	class SymItem implements java.awt.event.ItemListener {
		public void itemStateChanged(java.awt.event.ItemEvent e) {
			Object object = e.getSource();
			if (object == rbRange)
				rbRange_ItemStateChanged(e);
			else if (object == rbAllDates)
				rbAllDates_ItemStateChanged(e);
		}
	}

	void rbRange_ItemStateChanged(java.awt.event.ItemEvent e) {
		fromDate.setText("yyyy-mm-dd");
		toDate.setText("yyyy-mm-dd");
	}

	void rbAllDates_ItemStateChanged(java.awt.event.ItemEvent e) {
		fromDate.setText("");
		toDate.setText("");
	}
}