package cup.chap2.bugtrack;
import java.sql.*;
import java.util.Stack;

public class DBConnectionPool {

	private Stack connectionPool;
/**
	Construct a DB connection pool
**/
	private int num=0;
	public DBConnectionPool(String url, String driver,String user, String passwd, int numCon, boolean logging) {
		try {
			Class.forName(driver);	
			connectionPool = new Stack();
			num = numCon;
			if (logging)
				DriverManager.setLogStream(System.out);
			for (int i=0; i<numCon; i++) {
				connectionPool.push(DriverManager.getConnection(url, user,passwd));
			}

		} catch (SQLException e) {
			System.out.println("Error"+e);	
		} catch (ClassNotFoundException e) {
			System.out.println(driver +" not found:"+e);
		}
	}
/**
	getConnection() obtains a database connection from the 
	connection pool 
**/

	public synchronized Connection getConnection() {
		Connection c = null;
		try {
			if (!connectionPool.empty()) 
				c=(Connection) connectionPool.pop();
		} catch (Exception e) {
System.out.println("Error obtaining connection:"+e);
e.printStackTrace();
}
return c;
	}

/**
	freeConnection() releases a database connection back to the 
	pool after use
**/
	public synchronized void freeConnection(Connection c) {
		connectionPool.push(c);
	}

/**
	close all cached database connections on garbage collection
**/
	public void finalize() {
	while (!connectionPool.empty()){
				Connection c = (Connection) connectionPool.pop();
			try {
				c.close();
			} catch (SQLException e) {
			}
		}		
	}
}