package cup.chap3.rmiservlet;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.rmi.*;

//before servlet startup include path of jdk , . and servlets dir
//before registry &  rmi server startup include path of jdk , . 

public class RMIServlet extends HttpServlet {
	
	public TempConverterInterface tempServer =null;
	private int convDegrees ;
	private String cDegrees =null;
	private String fDegrees =null;

	public void init(ServletConfig config) throws ServletException {
		super.init(config);
	System.out.println("Within Init");

		try {
			if (System.getSecurityManager() == null)
			  System.setSecurityManager(new RMISecurityManager());

      tempServer = (TempConverterInterface) Naming.lookup("rmi://remotehost/TempServer");
		} catch (Exception e) {
			System.out.println("Error obtaining remote reference to TempServer");
			System.out.println(e);
		}
	}
	
	public void doPost(HttpServletRequest req,HttpServletResponse res)
	throws IOException	{	

		res.setContentType("text/html");

		String option = req.getParameter("convert");

		if (option.equals("ftoc")) {
			fDegrees = req.getParameter("degrees");
			int arg = new Integer(fDegrees).intValue();
 		 	convDegrees = tempServer.fToC(arg);
		} else if (option.equals("ctof")) {
			cDegrees = req.getParameter("degrees");
			int arg = new Integer(cDegrees).intValue();
 		 	convDegrees = tempServer.cToF(arg);
		}
ServletOutputStream out = res.getOutputStream();
		display(out);		
	}

	
	public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws IOException {	

		res.setContentType("text/html");
     ServletOutputStream out = res.getOutputStream();
		display(out);			
	}

	private void display(ServletOutputStream out) throws IOException {
		out.println("<HTML><HEAD><TITLE>RMI/Servlet Integration Demo");
		out.println("</TITLE></HEAD>");
		out.println("<BODY>");
		if (cDegrees != null) {
			out.println("<H1>"+cDegrees+"&deg; C = "+convDegrees+"&deg; F</H1>");
			cDegrees=null; 
		} else if (fDegrees != null) {
			out.println("<H1>"+fDegrees+"&deg; F = "+convDegrees+"&deg; C</H1>");
			fDegrees=null; 
		}
		out.println("<FORM METHOD=POST ACTION=http://host:port/servlet/rmiservlet>");
		out.println("<INPUT TYPE=radio NAME=convert VALUE=ftoc CHECKED>Fahrenheit to Celsius");
		out.println("<br>");
		out.println("<INPUT TYPE=radio NAME=convert VALUE=ctof>Celsius to Fahrenheit");
		out.println("<br>");
		out.println("<INPUT TYPE=text NAME=degrees>");
		out.println("<P>");
		out.println("<INPUT TYPE=submit VALUE=Convert>");
		out.println("</FORM></BODY></HTML>");
		out.close();
	}
}
