package cup.chap3.rmiservlet;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;

public class RMIlet extends HttpServlet 
implements Remote, Serializable, TempConverterInterface {
	
	//public TempConverterInterface tempServer =null;
	private int convDegrees ;
	private String cDegrees =null;
	private String fDegrees =null;
	private Registry registry =null;

	public void init(ServletConfig config) throws ServletException {
	
	super.init(config);
		System.out.println("Within Init");

		try {
			UnicastRemoteObject.exportObject(this);
			bindInRegistry();				
		} catch (Exception e) {
			System.out.println(e);
		}
	}
	
	public void doPost(HttpServletRequest req,HttpServletResponse res)
	throws IOException	{	

		res.setContentType("text/html");

		String option = req.getParameter("convert");

		if (option.equals("ftoc")) {
			fDegrees = req.getParameter("degrees");
			int arg = new Integer(fDegrees).intValue();
 		 	convDegrees = fToC(arg);
		} else if (option.equals("ctof")) {
			cDegrees = req.getParameter("degrees");
			int arg = new Integer(cDegrees).intValue();
 		 	convDegrees = cToF(arg);
		}
ServletOutputStream out = res.getOutputStream();
		display(out);		
	}

	public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws IOException {	

		res.setContentType("text/html");
     ServletOutputStream out = res.getOutputStream();
		display(out);			
	}

	private void display(ServletOutputStream out) {
		try {
		out.println("<HTML><HEAD><TITLE>RMI/Servlet Integration Demo");
		out.println("</TITLE></HEAD>");
		out.println("<BODY>");
		if (cDegrees != null) {
			out.println("<H1>"+cDegrees+"&deg; C = "+convDegrees+"&deg; F</H1>");
			cDegrees=null; 
		} else if (fDegrees != null) {
			out.println("<H1>"+fDegrees+"&deg; F = "+convDegrees+"&deg; C</H1>");
			fDegrees=null; 
		}
		out.println("<FORM METHOD=POST ACTION=http://localhost:8080/servlet/rmilet>");
		out.println("<INPUT TYPE=radio NAME=convert VALUE=ftoc CHECKED>Fahrenheit to Celsius");
		out.println("<br>");
		out.println("<INPUT TYPE=radio NAME=convert VALUE=ctof>Celsius to Fahrenheit");
		out.println("<br>");
		out.println("<INPUT TYPE=text NAME=degrees>");
		out.println("<P>");
		out.println("<INPUT TYPE=submit VALUE=Convert>");
		out.println("</FORM></BODY></HTML>");
		out.close();
		} catch (IOException e) {
			System.out.println("Err:"+e);
		}
	}

	public int fToC(int f) throws RemoteException {
		float c = (f-32)*5/9;
		Float cel = new Float(c);
		return cel.intValue();
	}

	public int cToF(int c) throws RemoteException {
		float f = (c+32)*9/5;
		Float fahren = new Float(f);
		return fahren.intValue();
	}
	
  public void bindInRegistry() {
	 try {
		registry = LocateRegistry.getRegistry(1099);
	 } catch (Exception e) {
		registry = null;
	 }
	 if (registry ==null) {
		try {
			registry = LocateRegistry.createRegistry(1099);
		} catch (Exception e) {
			System.out.println(e);
		}
	 }
	 try {
		registry.rebind("TempServer",this);
	 } catch (Exception e) {
		System.out.println(e);
	 }
  }
	
  public void destroy() {
		try {
			registry.unbind("TempServer");
		} catch (Exception e) {
			System.out.println(e);
		}
	}
}
