/**
	CallJava.c
	This native implementation demonstrates how we 
can receive and return complex Java objects from 
within native methods. We also see how native
methods can not only invoke methods of the parent 
object, but instantiate arbitrary Java objects.
*/

#include "CallJava.h"
JNIEXPORT jobject JNICALL Java_CallJava_promoteEmployee 
(JNIEnv *env, jobject obj, jobject empObj) {
	jclass clsEmp;
	jclass clsManager;
	jobject jo;
	jmethodID ctorManager ;
	jmethodID giveRaise;
	jstring newTitle;

	/* update the title field of the Java object passed 
        to native method */

	clsEmp = (*env)->GetObjectClass(env,empObj);
	jo = (jobject)(*env)->GetFieldID(env,clsEmp,"title",
							  "Ljava/lang/String;");
	newTitle = (*env)->NewStringUTF(env, "Java Programming Manager");
(*env)->SetObjectField(env,empObj,jo,newTitle);

	/* invoke the giveRaise method for the 
        Employee object */
	giveRaise = (jmethodID) 
(*env)->GetMethodID(env,clsEmp,"giveRaise","(D)V");
    (*env)->CallVoidMethod(env,empObj,giveRaise,  10000.00);

	/* create and return an instance of 
        the Manager class */

	clsManager =(jclass)(*env)->FindClass(env,"Manager");

	ctorManager = (jmethodID) (*env)->GetMethodID(env,clsManager,
"<init>","(LEmployee;D)V");

jo =(*env)->NewObject(env, clsManager,ctorManager, empObj,12000.00);
	return(jo);
}
