/**
	JNIObjAccess.c
	Native method implementation demonstrating
	basic string manipulation
*/

#include "JNIObjAccess.h"
JNIEXPORT jstring JNICALL 
Java_JNIObjAccess_askJNI (JNIEnv *env, jobject this, jstring arg) {

	char retstr[100];

	/* convert from unicode to UTF-8 */
	const char *msg =(*env)->GetStringUTFChars(env,arg,0);

	/* obtain the value of name within 
the invoking object */
jclass jc = (*env)->GetObjectClass(env,this);
	jfieldID jf =(*env)->GetFieldID(env,jc,"name",
"Ljava/lang/String;");
	jstring nameStr =(jstring)(*env)->GetObjectField(env,this,jf);
	const char *name = (*env)->GetStringUTFChars(env,nameStr,0);

	/*create the new string */
	sprintf(retstr, "%s - %s",name, msg);

	/* free memory to avoid leakage*/
	(*env)->ReleaseStringUTFChars(env,msg,0);
	(*env)->ReleaseStringUTFChars(env,name,0);

	/* return new string by wrapping it 
within a Java string object*/
	
return ((*env)->NewStringUTF(env,retstr));
}
