#include "MsgBuffer.h"
#include <stdio.h>

JNIEXPORT void JNICALL Java_MsgBuffer_consume(JNIEnv *env, jobject this) {

	jclass jc;
	jfieldID jf1;
	jfieldID jf2;
	jboolean avail;
	jmethodID jmet1;
	jmethodID jmet2;
	jmethodID jmet3;
	jmethodID jmet4;
	jstring msg;
	const char *msgBuffer;

	jc = (*env)->GetObjectClass(env, this);

	jf1 = (*env)->GetFieldID(env,jc,"msg","Ljava/lang/String;");
	jf2 = (*env)->GetFieldID(env,jc,"available","Z");
	jmet1 = (*env)->GetMethodID(env,jc,"wait","()V");
	jmet2= (*env)->GetMethodID(env,jc,"notifyAll","()V");
	jmet3 =(*env)->GetMethodID(env,jc,"setTrue","()V");
	jmet4 =(*env)->GetMethodID(env,jc,"setFalse","()V");
	
	while (!(*env)->GetBooleanField(env,this,jf2)) {
		(*env)->CallVoidMethod(env,this,jmet1);
	} 

	(*env)->CallVoidMethod(env,this,jmet4); 
	msg = (jstring) (*env)->GetObjectField(env,this,jf1);
	msgBuffer = (*env)->GetStringUTFChars(env,msg,0);
	printf("Consumer obtained:%s\n",msgBuffer);

	
	/* important to lock object before calling notifyAll
	   to prevent IllegalMonitorStateException 
   from getting thrown
	*/

	(*env)->MonitorEnter(env,this); 
	(*env)->CallVoidMethod(env,this,jmet2);
	(*env)->MonitorExit(env,this); 

}

JNIEXPORT void JNICALL Java_MsgBuffer_produce(JNIEnv *env, jobject this, jint i) {
	jclass jc;
	jfieldID jf1;
	jfieldID jf2;
	jboolean avail;
	jmethodID jmet1;
	jmethodID jmet2;
	jmethodID jmet3;
	jmethodID jmet4;
	jstring newmsg;
	char buf[100];
	
	jc = (*env)->GetObjectClass(env, this);

	jf1 = (*env)->GetFieldID(env,jc,"msg","Ljava/lang/String;");
	jf2 = (*env)->GetFieldID(env,jc,"available","Z");
	jmet1 = (*env)->GetMethodID(env,jc,"wait","()V");
	jmet2= (*env)->GetMethodID(env,jc,"notifyAll","()V");
	jmet3 =(*env)->GetMethodID(env,jc,"setTrue","()V");

	while ((*env)->GetBooleanField(env,this,jf2)) {
		(*env)->CallVoidMethod(env,this,jmet1);
	} 

	sprintf(buf,"Message #%d",i);
	newmsg = (*env)->NewStringUTF(env,buf);
	(*env)->SetObjectField(env,this,jf1,newmsg);

	printf("Producer created:%s\n",buf);
	
	(*env)->CallVoidMethod(env,this,jmet3);

	/* important to lock object before calling notifyAll
	   to prevent IllegalMonitorStateException 
   from getting thrown
	*/
	(*env)->MonitorEnter(env,this);  
	(*env)->CallVoidMethod(env,this,jmet2);
	(*env)->MonitorExit(env,this);  
}
