package cup.chap5.externalization;
import java.io.*;
import java.security.*;

public class AuthPerson implements Externalizable {
	private int id;
	private String name;
	private String dept;
	
	public AuthPerson() {
	//no-arg constructor
	}

	public AuthPerson(int id, String name, String dept) {
		this.id = id;
		this.name = name;
		this.dept = dept;
	}

	public void writeExternal(java.io.ObjectOutput out) 
		throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		DataOutputStream dos = new DataOutputStream(baos);
		try {
			dos.writeInt(id);
			dos.writeUTF(name);
			dos.writeUTF(dept);
			
			byte[] hash = computeHash(baos.toByteArray());
		
			out.writeObject(new String(baos.toByteArray()));
			out.writeObject(new String(hash));
		} catch (Exception e) {
System.out.println("error on writeExternal:"+e);
}
	}

	public void readExternal(java.io.ObjectInput in) 
		throws IOException, ClassNotFoundException {

		String streamData = (String) in.readObject();
		String originalHash = (String) in.readObject();
		byte[] tmpHash = computeHash(streamData.getBytes());
		
		if (!originalHash.equals(new String(tmpHash))) {
			throw new java.io.StreamCorruptedException();
		}
		ByteArrayInputStream bais = new ByteArrayInputStream(streamData.getBytes());
		DataInputStream dis = new DataInputStream(bais);

		id = (int) dis.readInt();
		name= (String) dis.readUTF();
		dept = (String) dis.readUTF();
	}

	private byte[] computeHash(byte[] data) {
		MessageDigest algorithm=null ;
		try {
			algorithm= MessageDigest.getInstance("SHA-1");
		} catch (NoSuchAlgorithmException e) {
			System.out.println(e.toString());
			System.exit(1);
		}

		algorithm.reset();			
		return (algorithm.digest(data));
	}

	public void print() {
		System.out.println("Id: "+id);
		System.out.println("Name: "+name);
		System.out.println("Department: "+dept);
		System.out.println("----");
	}
}
