package cup.chap5.sockets;
import java.net.*;
import java.io.*;
import java.util.*;


public class SerialServer extends Thread {
	private Socket channel;
	private ObjectOutputStream objOut;
	private ObjectInputStream objIn;

	public SerialServer(Socket s) {
		channel =s;
		try {
			objOut = new ObjectOutputStream(channel.getOutputStream());
			objIn = new ObjectInputStream(channel.getInputStream());
		} catch (Exception e) {
			System.out.println("Could not create channel with client"+e);
		}
	}

	public void run() {
		Person aPerson=null;
		try {
			aPerson = (Person) objIn.readObject();
			aPerson.print();
		} catch (Exception e) {
			System.out.println("error on read:"+e);
		}
		try {
			aPerson.setName("King Kong");
			aPerson.setAge(100);
			objOut.writeObject(aPerson);
		} catch (Exception e) {
			System.out.println("error on write");
		}
	}

	public static void main(String arg[]) {
		try {
			ServerSocket server = new ServerSocket(34145);
			while (true) {
				Socket channel = server.accept();
				SerialServer newSerial = 
new SerialServer(channel);
				newSerial.start();
			}
		} catch (Exception e) {
			System.out.println("Error on accept:"+e);	
		}
	}
}
