package cup.chap5.validation;
import java.io.*;
import java.util.Date;

public class ValidPerson implements Serializable {
	private int id;
      private  String name;
	private String dept;
	private transient String contact;

	public ValidPerson(int id, String name, String dept) {
		this.id = id;
		this.name = name;
		this.dept = dept;
		this.contact = resolveContact(dept);
	}
	
	private void writeObject(ObjectOutputStream oos) 
throws IOException {
	      
try {
      	     oos.defaultWriteObject();
		     oos.writeObject(new Date());
	      } catch(IOException e) { 
			System.out.println("Error in writeObject:"+e); 
		}
      }

	private String resolveContact(String d) {
		String tel="";
		if (d.equals("Marketing")) tel = "(212) 242-4343";
		else if (d.equals("Research")) tel = "(312) 322-4200";
		else if (d.equals("Product Development")) 
tel = "(650) 843-1210";
		else tel = "(800) 214-9943";
		return tel;
	}
	
      private void readObject(ObjectInputStream ois) 
throws IOException, ClassNotFoundException {
      	
try {
                 ois.defaultReadObject();
		     System.out.println("Validating Person<"+this.name+">");
		     this.contact = resolveContact(this.dept);
			Date oldDate = (Date) ois.readObject();
			Date newDate = new Date();
			long oldtime = oldDate.getTime();
			long newtime = newDate.getTime();
			long inactive =newtime - oldtime;
			System.out.println("Object was passive for "+	
				new Long(inactive).toString() + " ms");	
            } catch(Exception e) { 
			System.out.println("Error in readObject:"+e); 
		}
      }

	public void print() {
		System.out.println("Id: "+id);
		System.out.println("Name: "+name);
		System.out.println("Department: "+dept);
		System.out.println("Contact: "+contact);
		System.out.println("----");
	}
}
