package cup.chap6.activation; 

import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;
import java.io.File;

public class Bootstrap {

    // This class registers information about the CountServer
    // class with rmid and the rmiregistry
    //
    public static void main(String[] args) throws Exception {
CountInterface counter; 
	
	System.setSecurityManager(new RMISecurityManager());
	
	String location = "http://host:port/activation/";

	Properties props = new Properties();

	// Because of the Java 2 security model, file writing has to be
	// explicitly allowed
	props.put("java.security.policy","/policy");

        ActivationGroupDesc.CommandEnvironment ace = null;
	ActivationGroupID agi=
	    ActivationGroup.getSystem().registerGroup(
	                             new ActivationGroupDesc(props, ace));

	// Indicate filename we want to persist as the Marshalled object
	MarshalledObject data=
            new MarshalledObject(new File("/Count.ser"));

	ActivationDesc desc = new ActivationDesc(agi, "cup.chap6.activation.CountServer", location, data);
	
	counter = (CountInterface)Activatable.register(desc);

	//bind within rmiregistry
	Naming.rebind("/CountServer", counter);
	
	System.exit(0);
    }
}
