package cup.chap6.rmicallback;

import java.rmi.*;
import java.rmi.server.*;
import java.util.Random;
import java.awt.*;
import java.applet.*;

public class QuoteApplet extends Applet implements QClientInterface {

	public void init() {
		setLayout(null);
		setSize(426,237);
		label = new java.awt.Label("Input Quote:");
		label.setBounds(12,24,72,24);
		add(label);
		sendButton = new java.awt.Button();
		sendButton.setLabel("Send");
		sendButton.setBounds(348,24,60,24);
		sendButton.setBackground(new Color(12632256));
		add(sendButton);
		quotes = new java.awt.TextArea();
		quotes.setBounds(36,60,372,156);
		add(quotes);
		myQuote = new java.awt.TextField();
		myQuote.setBounds(84,24,252,28);
		add(myQuote);
		
		SymAction lSymAction = new SymAction();
		sendButton.addActionListener(lSymAction);

		try {
			//by exporting the client object, turn it into a
			//remote object 
			UnicastRemoteObject.exportObject(this);
		} catch (Exception e) {
			System.out.println("Could not export client remote object");
			System.out.println(e);
	      }
		try {
		    //obtain the remote server object's reference by interrogating the
		   //rmi registry
  	  	    srvQuote = (QServerInterface) 
				Naming.lookup("//"+getCodeBase().getHost()+"/QuoteServer");
		   srvQuote.setQClientInterface(this);
		} catch (Exception e) {
			System.out.println("Could not set client interface at server");
			System.out.println(e.toString());
		}


	}
	
public void refreshClient(String q) throws java.rmi.RemoteException {
	//this is the callback method implementation
		quotes.append(q+"\n");
}

	java.awt.Label label;
	java.awt.Button sendButton;
	java.awt.TextArea quotes;
	java.awt.TextField myQuote;
	QServerInterface  srvQuote=null;


	class SymAction implements java.awt.event.ActionListener {
		public void actionPerformed(java.awt.event.ActionEvent ex) {
			Object object = ex.getSource();
			if (object == sendButton)
				sendButton_ActionPerformed(ex);
		}
	}

void sendButton_ActionPerformed(java.awt.event.ActionEvent e){
		try {
			//update the remote server object with a new quote
			srvQuote.addQuote((String)myQuote.getText());
		} catch (Exception ex) {
			System.out.println(ex.toString());
		}

		myQuote.setText("");

	}
}
