package cup.chap6.rmiexample;
import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class EmployeeServer extends UnicastRemoteObject implements EmployeeInterface {
	private String srvname ;
	private Employee[] employees = { 
		 new Employee(100,"Human Resources", "Jenny Jenkins"),
		 new Employee(101,"Product Development", "Karl Schenke"),
		 new Employee(102,"Product Development","Ter Parr"),
		 new Employee(103,"Product Development","Rusty Harris") 
		};

public EmployeeServer (String serverName)throws
            java.rmi.RemoteException{
		super();
		srvname=serverName;
	}

	public Employee lookup(int empID) throws RemoteException {
            for (int i=0;i<employees.length;i++)
			if (empID == employees[i].getId()) 
				return employees[i];
		return null;
	}

	public static void main(String[] args) {
	  System.setSecurityManager(new RMISecurityManager());

	  try {
	        EmployeeServer myEmployeeServer = new EmployeeServer("EmployeeServer");
	        Naming.bind("/EmployeeServer", myEmployeeServer);
	        System.out.println("EmployeeServer bound in registry");
	      }
	      catch (Exception e) {
		  System.out.println("Exception on bind "+e.toString());
	        e.printStackTrace();
	      }
	  } 
}
