package cup.chap6.rot13;

import java.io.*;

public class Rot13InputStream extends FilterInputStream 
   implements Rot13Constants {
  
   public Rot13InputStream(InputStream in) {

       super(in);
   }
  
   public int read() throws IOException {

      int x = in.read(); 
	if (x >=UPPERCASE_A && x <=UPPERCASE_Z)
	   x = rot13(x);
	else if (x >=LOWERCASE_A && x <= LOWERCASE_Z) {
	   char up = Character.toUpperCase((char)x);
         x =(int)Character.toLowerCase((char)rot13((int)up));     
      }
      return x;
  }
  
  private int rot13(int code) {

       int encoded = code + ROT13KEY;
	 if (encoded >UPPERCASE_Z) 
	    encoded = UPPERCASE_A + (encoded % UPPERCASE_Z) -1;
	 return encoded;
  }

  public int read(byte b[], int off, int len) throws IOException {

      int numBytes = in.read(b, off, len);
      if (numBytes <= 0)
         return numBytes;

      int i = 0; 
      for(; i < numBytes; i++) {
	   int num = (int)b[off+i];
	   if (num >=UPPERCASE_A && num <=UPPERCASE_Z) {
            int decodedChar = rot13(num);
		b[off+i] = (byte)decodedChar;		                
   	   } else if (num >=LOWERCASE_A && num <= LOWERCASE_Z) {
	      int decodedChar= 
         rot13((int)Character.toUpperCase((char)b[off+i]));
		b[off+i] = (byte)Character.toLowerCase((char)decodedChar);
	   }
      }
      return i;
  }
}
