package cup.chap6.rot13;

import java.io.*;

public class Rot13OutputStream extends FilterOutputStream 
    implements Rot13Constants { 

    public Rot13OutputStream(OutputStream out) {
    
       super(out);
    }

    private int rot13(int code) {

       int encoded = code + ROT13KEY;
	 if (encoded >UPPERCASE_Z) 
	    encoded = UPPERCASE_A + (encoded % UPPERCASE_Z) -1;
	 return encoded;
    }

    public void write(int x) throws IOException {
	  
       if (x >= UPPERCASE_A && x <= UPPERCASE_Z)
	    x = rot13(x);
   	 else if (x >= LOWERCASE_A && x <= LOWERCASE_Z) {
	    char up = Character.toUpperCase((char)x);
	    x = (int)Character.toLowerCase((char)rot13((int)up));                
	 }
	 out.write(x);
       out.flush();
    }
  
    public void write(byte b[], int off, int len) throws IOException {
       
       for (int i = 0; i < len; i++)
          write((int)b[off + i]);
    }
}
