package cup.chap6.rot13;

import java.io.*;
import java.net.*;
import java.util.*;

public class Rot13Socket extends Socket {
      
   private InputStream in = null;
   private OutputStream out = null;

   public Rot13Socket() throws IOException     {
      
      super();	
   }
  
   public Rot13Socket(String host, int port) throws IOException  {
      
      super(host, port);	
   }
  
   public synchronized InputStream getInputStream()throws IOException {

      if (in == null) 
         in = new Rot13InputStream(super.getInputStream());
      return in;
    }
  
    public synchronized OutputStream getOutputStream() 
       throws IOException {

       if (out == null) 
          out = new Rot13OutputStream(super.getOutputStream());
       return out;
    }

    public synchronized void close() throws IOException {

       OutputStream o = getOutputStream();
       o.flush();
       super.close();
    }
}
