package cup.chap6.rot13;

import java.io.*;
import java.rmi.*;
import java.rmi.server.*;

public class SoothsayerImpl extends UnicastRemoteObject 
    implements Soothsayer {
  
    public SoothsayerImpl(String protocol) throws RemoteException {

       super(0, new CaesarClientSocketFactory(protocol),
          new CaesarServerSocketFactory(protocol));
    }

    public String seekCounsel(String name) throws RemoteException {

       return name+": Beware the Ides of March!";
    }
  
    public static void main(String[] args) {

       if (System.getSecurityManager() == null)
	    System.setSecurityManager(new RMISecurityManager());

	 try {
	    SoothsayerImpl obj = new SoothsayerImpl("rot13");  
	    Naming.rebind("/Soothsayer", obj);
	    System.out.println("Soothsayer bound in registry");
	 } catch (Exception e) {
	    System.out.println("SoothsayerImpl err: " + e.toString());
	 }
    }
} 
