

// Client.java, stringified object reference version
package cup.chap7.ex72;

import java.io.*;
import org.omg.CORBA.*;
import Interest.*;

public class Client { 
  
  public static void main (String args[]) { 
    
    try {
      // create and initialize the ORB
      ORB orb = ORB.init (args, null);

      // Get the stringified object reference and destringify it.
      String filename = System.getProperty ("user.home")+
                        System.getProperty ("file.separator")+"RatesIOR";
      FileInputStream fis = new FileInputStream (filename);
      DataInputStream dis = new DataInputStream (fis) ;
      String ior = dis.readLine () ;
      org.omg.CORBA.Object obj = orb.string_to_object (ior) ;

      Rates ratesRef = RatesHelper.narrow (obj);

      // call the Interest server object and print results
      System.out.println ("Interest Rates provided by " + 
                          "The Lake Side Credit Union\n"); 
      System.out.println ("    Premium Checkings Interest = " + 
                          ratesRef.getPremiumChecking () + "%");
      System.out.println ("    Premium Savings Interest   = " + 
                          ratesRef.getPremiumSavings () + "%");
      System.out.println ("    Economy Checkings Interest = " +
                          ratesRef.getEconomyChecking () + "%");
      System.out.println ("    Economy Savings Interest   = " +
                          ratesRef.getEconomySavings () + "%");

    } catch (Exception e) {
      
      e.printStackTrace ();
    }
  }
}