
// Server.java, stringified object reference version
package cup.chap7.ex72;

import java.io.*;
import org.omg.CORBA.*;
import Interest.*;

class InterestRates extends _RatesImplBase {
  
  private static final float _premiumChecking = 0.55f;
  private static final float _premiumSavings  = 2.10f;
  private static final float _economyChecking = 0.20f;
  private static final float _economySavings  = 1.50f;
  
  public float getPremiumChecking () { return _premiumChecking; }
  public float getPremiumSavings ()  { return _premiumSavings; }
  public float getEconomyChecking () { return _economyChecking; }
  public float getEconomySavings ()  { return _economySavings; }
}

public class Server {

  public static void main (String args[]) { 
    
    try {
      // create and initialize the ORB
      ORB orb = ORB.init (args, null);

      // create servant and register it with the ORB
      InterestRates ratesRef = new InterestRates ();
      orb.connect (ratesRef);

      // stringify the ratesRef and dump it in a file
      String str = orb.object_to_string (ratesRef);
      String filename = System.getProperty ("user.home")+
                        System.getProperty ("file.separator")+"RatesIOR";
      FileOutputStream fos = new FileOutputStream (filename);
      PrintStream ps = new PrintStream (fos);
      ps.print (str);
      ps.close ();

      // Wait forever for current thread to die
      Thread.currentThread ().join ();	 

    } catch (Exception e) {
      
      e.printStackTrace ();
    }
  }
}