
// CheckingsAccountImpl.java
package  cup.chap7.ex73;
					   
import java.util.*;
public class CheckingsAccountImpl 
  extends Bank._CheckingsAccountImplBase {

  private Dictionary _accountsTable= new Hashtable ();
  private Random		 _random		   = new Random ();
  
  public CheckingsAccountImpl () {
    
    super ();
    System.out.println ("Created CheckingsAccount Server");
  }
  
  public synchronized Bank.Account open(String name) {
    
    // Lookup the account in the account dictionary.
    Bank.Account account = (Bank.Account) _accountsTable.get (name);
    // Return the account.	 
    return account;  
  }
  
  public synchronized Bank.Account credit(String name, float amount) 
    throws Bank.InvalidTransaction {
    
    // Lookup the account in the account dictionary.
    Bank.Account account = (Bank.Account) _accountsTable.get (name);
    if (amount > 0)
      account.setBalance (account.getBalance ()+amount);
    // Return the account.	 
    return account;  
  }

  public synchronized Bank.Account debit(String name, float amount)
    throws Bank.InvalidTransaction {
    
    // Lookup the account in the account dictionary.
    Bank.Account account = (Bank.Account) _accountsTable.get (name);
    if (amount > 0)
      account.setBalance (account.getBalance ()-amount);
    // Return the account.	 
    return account;  
  }

  public synchronized Bank.Account create(String name, float balance) {
    
    // Lookup the account in the account dictionary.
    Bank.Account account = (Bank.Account) _accountsTable.get (name);
    // If the account is not in the dictionary, create an account.
    if (account == null) {
      // Create the account implementation, given the balance.
      account = new AccountImpl (balance);
      // Make the object available to the ORB.	 	 
      // Export the newly created object	 	 
      _orb ().connect (account);
      System.out.println ("Created " + name + "'s account: " + account);
      // Save the account in the account dictionary.
      _accountsTable.put (name, account);	 
    }	 
    // Return the account.	 
    return account;  
  }
  
}