
// Client.java
package  cup.chap7.ex73;

public class Client {
  
  public static void main (String[] args) {
    
    try {
      // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init (args,null);
      
      // Get a reference to the Naming Service
      org.omg.CORBA.Object nameServiceObj = 
              orb.resolve_initial_references ("NameService");
      if ( nameServiceObj == null ) {
        System.out.println ("nameServiceObj = null");
        return;
      }
      
      // Narrow the object
      org.omg.CosNaming.NamingContext nameService = 
      org.omg.CosNaming.NamingContextHelper.narrow (nameServiceObj);
      
      if( nameService == null ) {
        System.out.println ("nameService = null");
        return;
      }
      
      // Locate an object called CheckingsAccount
      // relative to the initial namecontext
      org.omg.CosNaming.NameComponent[] accountName = { 
        new org.omg.CosNaming.NameComponent ("CheckingsAccount", "")
      };
      Bank.CheckingsAccount checkingsAccount = 
      Bank.CheckingsAccountHelper.narrow (nameService.resolve (accountName));
      
      nameService.rebind (accountName, checkingsAccount);

      // use args[1] as the account name, or a default.
      String op = args.length > 0 ? args[0] : "-c";
      String name = args.length > 1 ? args[1] : "Athul";
      float amount = args.length > 2 ? 
                     (new Float (args[2])).floatValue () : 1000;
      
      // Request the CheckingsAccount to open a named account.
      Bank.Account account = null;
      try {
        if (op.equals("-c")) 
          account = checkingsAccount.create (name, amount);
        if (op.equals("-o")) 
          account = checkingsAccount.open (name);
        if (op.equals("-cr")) 
          account = checkingsAccount.credit (name, amount);
        if (op.equals("-db")) 
          account = checkingsAccount.debit (name, amount);
      } catch (Exception e) { e.printStackTrace(); }
      
      // Get the balance of the account.
      float balance = account.getBalance ();
      // Print out the balance.
      System.out.println ("The balance in " + name + "'s account is $" 
                          + balance);
    } catch (Exception e) { e.printStackTrace (); }
  }
}
