
// Server.java
package  cup.chap7.ex73;

import org.omg.CosNaming.*;

public class Server {  

 public static void main (String[] args) {
  
  try {
   // Initialize the ORB.
   org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init (args,null);
   System.out.println ("Orb Initialized.");
   // Create the account CheckingsAccount object.	 	 
   Bank.CheckingsAccount checkingsAccount = new CheckingsAccountImpl ();
   if (checkingsAccount == null) {
    System.out.println ("CheckingsAccount = null");
    return;
   }

   // Export the newly created object	 	 
   orb.connect (checkingsAccount);
   System.out.println ("CheckingsAccountServer is connected.");
   
   // Get a reference to the Naming Service
   org.omg.CORBA.Object nameServiceObj = 
   orb.resolve_initial_references ("NameService");
   
   if (nameServiceObj == null) {
    System.out.println ("nameServiceObj = null");
    return;
   }
   // Narrow the object
   org.omg.CosNaming.NamingContext nameService = 
   org.omg.CosNaming.NamingContextHelper.narrow (nameServiceObj);
   
   if (nameService == null) {
    System.out.println ("nameService = null");
    return;
   }
   
   // bind the CheckingsAccount object in the Naming Service
   org.omg.CosNaming.NameComponent[] accountName = { 
    new org.omg.CosNaming.NameComponent ("CheckingsAccount", "")};
   nameService.rebind (accountName, checkingsAccount);

   // Wait forever for current thread to die
   Thread.currentThread ().join ();	 
  } catch (Exception e) { e.printStackTrace (); }
  
 }
}