
// Cos/Event/PullConsume.javaimport org.omg.CosEventComm.*;
import org.omg.CosNaming.*;// Server will use the naming service.
import org.omg.CosNaming.NamingContextPackage.*; // The package containing special exceptions thrown by the name service.
import org.omg.CORBA.*;// All CORBA applications need these classes.
import org.omg.CosEventChannelAdmin.*;
import org.omg.CosEventComm.*;
import java.io.DataInputStream;

public class PullConsume extends _PullConsumerImplBase {
  public static void main(String[] args) {	   
    try {
      // Create and initialize the ORB
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
      EventChannel channel = null;	      
      PullConsume view = null;
      ProxyPullSupplier pullSupplier = null;
      DataInputStream in = new DataInputStream(System.in);

      NamingContext root = 
                          NamingContextHelper.narrow( orb.resolve_initial_references("EventService") );
      NameComponent[] name = new NameComponent[1] ;
      name[0] = new NameComponent("EventChannel","");
      channel = EventChannelHelper.narrow(root.resolve(name));

      System.out.println("Located event channel: ");
      view = new PullConsume();
      orb.connect(view);
      System.out.println("Created view: " + view);	      
      pullSupplier = channel.for_consumers().obtain_pull_supplier();
      System.out.println("Obtained pull supplier: " + pullSupplier);
      System.out.println("Connecting...");	      
      System.out.flush();
      pullSupplier.connect_pull_consumer(view);	      
      while(true) {
        System.out.print("-> ");		
        System.out.flush();
        if (System.getProperty("VM_THREAD_BUG") != null) {
          while(in.available() == 0) {		      
            try { Thread.currentThread().sleep(100);	} 
            catch(InterruptedException e) {}		   
          }		
        }
        String line = in.readLine();		
        if(line.startsWith("a")) {
          org.omg.CORBA.BooleanHolder hasEvent =
                                                new org.omg.CORBA.BooleanHolder();		   
          org.omg.CORBA.Any result = pullSupplier.try_pull(hasEvent);		   
          System.out.println("try_pull: " + (hasEvent.value ? result.toString() : "NO DATA"));		   
          continue;		
        }
        else if(line.startsWith("s")) {
          org.omg.CORBA.Any result = pullSupplier.pull();
          System.out.println("pull: " + result);		   
          continue;		
        }
        else if(line.startsWith("q")) {		   
          System.out.println("Disconnecting...");
          pullSupplier.disconnect_pull_supplier();
          System.out.println("Quitting...");		   
          break;		
        }
        System.out.println("Commands: a  [a]synchronous pull\n" +
                           "          s  [s]ynchronous pull\n" +		   
                           "          q  [q]uit\n");	
      }
    } catch(Exception e) {e.printStackTrace();}
  }
  
  public void disconnect_pull_consumer() { 
  }
}