
// Cos/Event/PullSupply.javaimport org.omg.CosEventComm.*;
import org.omg.CosNaming.*;// Server will use the naming service.
import org.omg.CosNaming.NamingContextPackage.*; // The package containing special exceptions thrown by the name service.
import org.omg.CORBA.*;// All CORBA applications need these classes.
import org.omg.CosEventChannelAdmin.*;
import org.omg.CosEventComm.*;
import java.io.DataInputStream;
import org.omg.CORBA.SystemException;

public class PullSupply extends _PullSupplierImplBase { 
  private PullConsume _pullConsumer = null;
  private int         _counter = 0;
  
  public PullSupply(PullConsume clone) {
    _pullConsumer = clone;
  }
  
  public static void main(String[] args) {	   
    try {
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args, null);
      EventChannel channel = null;	      
      PullSupply model = null;
      ProxyPullConsumer pullConsumer = null;
      
      NamingContext root = 
                          NamingContextHelper.narrow( orb.resolve_initial_references("EventService") );
      NameComponent[] name = new NameComponent[1] ;
      name[0] = new NameComponent("EventChannel","");
      channel = EventChannelHelper.narrow(root.resolve(name));

      
      System.out.println("Located event channel: " + channel);
      pullConsumer = channel.for_suppliers().obtain_pull_consumer();
      System.out.println("Obtained pull consumer: " + pullConsumer);
      PullConsume clone = (PullConsume)PullConsumerHelper.narrow(pullConsumer._duplicate());
      model = new PullSupply(clone);
      root.rebind(name, model);
      System.out.println("Created model: " + model);
      System.out.println("Connecting ...");
      pullConsumer.connect_pull_supplier(model);	      

      // Wait forever for current thread to die
      Thread.currentThread().join();	 
    } catch(Exception e) { e.printStackTrace (); }	
  }
  
  public org.omg.CORBA.Any pull() throws Disconnected {
    if(_pullConsumer == null) {	      
      throw new Disconnected();	   
    }	   
    try {
      Thread.currentThread().sleep(1000);	   
    } catch(Exception e) {}
    org.omg.CORBA.Any message = _orb().create_any();
    message.insert_string("Hello #" + ++_counter);
    System.out.println("Supplier being pulled: " + message);	   
    return message;
  }	
  
  public org.omg.CORBA.Any try_pull(org.omg.CORBA.BooleanHolder hasEvent)
    throws org.omg.CORBA.SystemException, Disconnected {
    hasEvent.value = true;	   
    return pull();	
  }
  
  public void disconnect_pull_supplier() { 
  }
}