/**
 * Copyright (C) 1998-1999, Gopalan Suresh Raj.
 * All Rights Reserved.
 * 
 * This source code is part of a CORBA tutorial 
 * being developed by me.
 * 
 * See detailed instructions at my web site at
 * http://www.execpc.com/~gopalan
 * 
 */

import java.io.*;
import org.omg.CORBA.*;
import cup.chap7.ex74.EventChannel.CosEventChannelAdmin.*;

public class ShareChannel { 
 public static void main( String args[]) { 
  try { 
   ORB orb = ORB.init( args, new java.util.Properties());
   // javaIDL doesn't require a BOA to be created, but maybe other
   // ORBs.
   // BOA boa = m_orb.BOA_init( args, new java.util.Properties());

   // Depending on the event service implementation you possibly
   // have to pass an argument to the constructor of EventChannel.
   // E.g. the event service of ORBacus 3.1 requires the orb object
   // to be passed: com.ooc.CosEventChannelAdmin.EventChannel( orb).
   org.omg.CosEventChannelAdmin.EventChannel eventChannel =
        new cup.chap7.ex74.EventChannel.CosEventChannelAdmin.EventChannel();
   try { 
    String ref = orb.object_to_string( eventChannel);
    String refFile = "../SWBChannel.ior";
    FileOutputStream file = new FileOutputStream( refFile);
    PrintStream out = new PrintStream( file);
    out.println( ref);
    out.flush();
    file.close();
   }
   catch( IOException ex) { 
    System.err.println( "Can't write to '" + ex.getMessage() + "'");
    System.exit(1);
   }
   // Instead of calling boa.impl_is_ready, javaIDL uses the
   // following code.

   // javaIDL.
   orb.connect( eventChannel);

   try { 
    java.lang.Object sync = new java.lang.Object();
    synchronized (sync) { 
     sync.wait();
    }
   }
   catch( java.lang.InterruptedException ex) { 
   }
   // javaIDL.

   // For other ORBs use boa.impl_is_ready.
   // boa.impl_is_ready( null);
  }
  catch( SystemException ex) { 
   System.out.println( "SystemException");
  }
 }
}
