/**
 * Copyright (C) 1998-1999, Gopalan Suresh Raj.
 * All Rights Reserved.
 * 
 * This source code is part of a Java/RMI tutorial 
 * being developed by me.
 * 
 * See detailed instructions at my web site at
 * http://www.execpc.com/~gopalan
 * 
 */
// StockMarketImpl.java

package SimpleStocks;

import java.rmi.*;
import java.rmi.server.UnicastRemoteObject;

public class StockMarketImpl 
  extends UnicastRemoteObject implements StockMarket { 

  public StockMarketImpl( String name ) throws RemoteException { 
    try { 
      Naming.rebind( name, this );
    }
    catch( Exception e ) { 
      System.out.println( e );
    }
  }

  public float get_price( String symbol ) { 
    float price = 0;
    for( int i = 0; i < symbol.length(); i++ ) { 
      price += (int) symbol.charAt( i );
    }
    price /= 5;
    return price;
  }

} 