
// StockMarketClient.java

import org.omg.CORBA.*;     // All CORBA applications need these classes.
import org.omg.CosNaming.*; // Client will use the naming service
import SimpleStocks.*;      // The package containing our stubs.

public class StockMarketClient {
  
  public static void main(String[] args) {
    
    try {
      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);
      
      // Get the root naming context
      NamingContext ncRef = NamingContextHelper.narrow(orb.resolve_initial_references("NameService"));

      // Resolve the object reference in naming      
      NameComponent path[] = {new NameComponent("NASDAQ", "")};
      StockMarket market = StockMarketHelper.narrow(ncRef.resolve(path));
      
      // Call the time server object and print results      
      System.out.println("Price of MY COMPANY is " + market.get_price("MY_COMPANY"));
    } catch( Exception e ) {
      e.printStackTrace();
    }
    
  }
  
}