

// StockMarketServer Main

import org.omg.CORBA.*;     // All CORBA applications need these classes.
import org.omg.CosNaming.*; // Server will use the naming service.
import SimpleStocks.*;      // The package containing our stubs

public class StockMarketServer {
  
  public static void main(String[] args) {
    
    try {
      // Create and initialize the ORB
      ORB orb = ORB.init(args, null);

      // Create the servant and register it with the ORB
      StockMarketImpl stockMarketImpl = new StockMarketImpl();
      orb.connect(stockMarketImpl);

      // Get the root naming context
      org.omg.CORBA.Object objRef = orb.resolve_initial_references("NameService");
      NamingContext ncRef = NamingContextHelper.narrow(objRef);
      
      // Bind the object reference in naming
      NameComponent nc = new NameComponent("NASDAQ", "");
      NameComponent path[] = {nc};
      ncRef.rebind(path, stockMarketImpl);
      
      System.out.println("The StockMarket Server is up and ready...");

      // Wait forever for current thread to die
      Thread.currentThread().join();	 
    }
    catch( Exception e ) { e.printStackTrace(); }
  }
  
}