package cup.chap8.Shop.Books;

import java.rmi.*;
import javax.ejb.*;

public class BooksBean implements EntityBean { 
  
  EntityContext entityContext;
  
  public int    code;		  // CODE
  public String title;	  // TITLE
  public String authors;	// AUTHORS
  public double price;	  // PRICE
  public int    discount;	// DISCOUNT

  // Implementation for all the Remote Interface business methods
  public int    getIsbn() throws RemoteException { 
    
    return code; 
  }
  
  public String getTitle() throws RemoteException { 
    
    return title; 
  }
  
  public String getAuthors() throws RemoteException { 
    
    return authors; 
  }
  
  public double getPrice() throws RemoteException { 
    
    return price; 
  }
  
  public int    getDiscount() throws RemoteException { 
    
    return discount; 
  }
  
  public double getDiscountedPrice() throws RemoteException { 
    
    double deduct = ((double)discount)/100;
    return ( price*(1-deduct) ); 
  }
  
  public void   setPrice( double cost ) throws RemoteException { 
    
    price = cost; 
  }
  
  public void   setDiscount( int disc )throws RemoteException { 
    
    discount = disc; 
  }
  
  // Implementation for all the Home Interface methods
  public void ejbCreate(int isbn, String bookTitle, String author,
                        double cost, int disc)
    throws CreateException, RemoteException { 
    
    code    = isbn;
    title   = bookTitle;
    authors = author;
    price   = cost;
    discount= disc;
  }
  
  public void ejbPostCreate(int isbn, String bookTitle, String author,
                            double cost, int disc) {
  }
  

  public void ejbActivate() throws RemoteException{}
  public void ejbLoad() throws RemoteException{}
  public void ejbPassivate() throws RemoteException{}
  public void ejbRemove() throws RemoteException, RemoveException{}
  public void ejbStore() throws RemoteException{}

  public void setEntityContext(EntityContext context) 
    throws RemoteException { 
    
    entityContext = context; 
  }

  public void unsetEntityContext() throws RemoteException {
    
    entityContext = null; 
  }
  
}

