
package cup.chap8.Shop.Cart;

import javax.ejb.*;
import java.rmi.*;
import java.util.*;
import cup.chap8.Shop.Books.*;
import cup.chap8.Shop.Music.*;

public interface Cart extends EJBObject { 
  
  public Books  createNewBook (int isbn, String title, String authors, 
                               double price, int discount) 
    throws RemoteException, CreateException;
  public Music  createNewAlbum (int code, String album, String authors, 
                                double price, int discount) 
    throws RemoteException, CreateException;
  public Books  getBook (int isbn) 
    throws RemoteException, FinderException;
  public Music  getAlbum (int code) 
    throws RemoteException, FinderException;
  public void   addToBooksCart (int code) throws RemoteException;
  public void   addToMusicCart (int code) throws RemoteException;
  public void   flushBooksCart () throws RemoteException;
  public void   flushMusicCart () throws RemoteException;
  public int    getNumberBooks () throws RemoteException;
  public int    getNumberAlbums () throws RemoteException;
  public double getBooksTotal () throws RemoteException;
  public double getAlbumsTotal () throws RemoteException;
  public double getGrandTotal () throws RemoteException;
  public Vector getBooksList () throws RemoteException;
  public Vector getMusicList () throws RemoteException;
  public Vector getBooksCart () throws RemoteException;
  public Vector getMusicCart () throws RemoteException;
}
