package cup.chap8.Shop.Cart;

import java.rmi.*;
import java.util.*;

public class CartTest { 
  
  static final int NUMITEMS = 2;
  
  public static void main (String[] args) throws Exception { 
    
    CartHome home = (CartHome)Naming.lookup ("Cart");
    System.out.println ("Naming.lookup successful...");
    if (null == home) { 
      System.out.println ("null CartHome returned...");
    }
    Cart cart = home.create ();
    String title = "Title";
    String author= "Author";
    
    for (int i = 0; i < CartTest.NUMITEMS; i++) { 
      System.out.println ("code = " +(i+1) + 
                          " Title = " +title+(i+1) + 
                          " Author = " +author+(i+1) + 
                          " Creating cart.create...");
      cart.createNewBook ((i+1),title+(i+1),author+(i+1),100.00,10);
      cart.createNewAlbum ((i+1),title+(i+1),author+(i+1),20.00,5);
    }
    
    for (int i = 0; i < CartTest.NUMITEMS; i++) { 
      cart.addToBooksCart (i+1);
      cart.addToMusicCart (i+1);
    }
    
    Vector bookList = cart.getBooksList ();
    System.out.println ("Book List of size "+
                        bookList.size ()+" is...");
    for (int i = 0; i < bookList.size(); i++) { 
      ReturnSet set = (ReturnSet)bookList.elementAt (i);
      System.out.println ("code = " +set.code + 
                          " Title = " +set.title + 
                          " Author = " +set.authors);
    }
    
    Vector musicList= cart.getMusicList ();
    System.out.println ("Music List of size "+
                        musicList.size ()+" is...");
    for (int i = 0; i < musicList.size(); i++) { 
      ReturnSet set = (ReturnSet)musicList.elementAt (i);
      System.out.println ("code = " +set.code + 
                          " Title = " +set.title + 
                          " Author = " +set.authors);
    }
    
    Vector bookCart = cart.getBooksCart ();
    System.out.println ("Book Cart of size "+
                        bookCart.size ()+" is...");
    for(int i = 0; i < bookCart.size (); i++) { 
      ReturnSet set = (ReturnSet)bookCart.elementAt (i);
      System.out.println ("code = " +set.code + 
                          " Title = " +set.title + 
                          " Author = " +set.authors);
    }

    Vector musicCart = cart.getMusicCart ();
    System.out.println ("Music Cart of size "+
                        musicCart.size ()+" is...");
    for (int i = 0; i < musicCart.size (); i++) { 
      ReturnSet set = (ReturnSet)musicCart.elementAt (i);
      System.out.println ("code = " +set.code + 
                          " Title = " +set.title + 
                          " Author = " +set.authors);
    }
    
    System.out.println ("Total Books = " +cart.getNumberBooks () +
                        " Total Albums = " +cart.getNumberAlbums () + 
                        " Book Cost = " +cart.getBooksTotal () + 
                        " Album Cost = " +cart.getAlbumsTotal () + 
                        " Grand Total =" + cart.getGrandTotal ());
  }
}

